
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Coin_codesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coin_codes = await db.coin_codes.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        pin: data.pin
        ||
        null
            ,
            
        amount_doodlecoins: data.amount_doodlecoins
        ||
        null
            ,
            
        max_redemptions: data.max_redemptions
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
        success_message: data.success_message
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return coin_codes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const coin_codesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                pin: item.pin
            ||
            null
            ,
            
                amount_doodlecoins: item.amount_doodlecoins
            ||
            null
            ,
            
                max_redemptions: item.max_redemptions
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
                success_message: item.success_message
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const coin_codes = await db.coin_codes.bulkCreate(coin_codesData, { transaction });

        // For each item created, replace relation files
        

        return coin_codes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const coin_codes = await db.coin_codes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.pin !== undefined) updatePayload.pin = data.pin;
        
        
        if (data.amount_doodlecoins !== undefined) updatePayload.amount_doodlecoins = data.amount_doodlecoins;
        
        
        if (data.max_redemptions !== undefined) updatePayload.max_redemptions = data.max_redemptions;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        if (data.success_message !== undefined) updatePayload.success_message = data.success_message;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await coin_codes.update(updatePayload, {transaction});

        
        

        
        

        

        return coin_codes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coin_codes = await db.coin_codes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of coin_codes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of coin_codes) {
                await record.destroy({transaction});
            }
        });


        return coin_codes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const coin_codes = await db.coin_codes.findByPk(id, options);

        await coin_codes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await coin_codes.destroy({
            transaction
        });

        return coin_codes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const coin_codes = await db.coin_codes.findOne(
            { where },
            { transaction },
        );

        if (!coin_codes) {
            return coin_codes;
        }

        const output = coin_codes.get({plain: true});

        
        
        
        
        
        
        
        
        output.coin_code_redemptions_coin_code = await coin_codes.getCoin_code_redemptions_coin_code({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coin_codes',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.pin) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coin_codes',
                        'pin',
                        filter.pin,
                    ),
                };
            }
            
            if (filter.success_message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coin_codes',
                        'success_message',
                        filter.success_message,
                    ),
                };
            }
            

            
            

            
            if (filter.amount_doodlecoinsRange) {
                const [start, end] = filter.amount_doodlecoinsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount_doodlecoins: {
                    ...where.amount_doodlecoins,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount_doodlecoins: {
                    ...where.amount_doodlecoins,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_redemptionsRange) {
                const [start, end] = filter.max_redemptionsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_redemptions: {
                    ...where.max_redemptions,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_redemptions: {
                    ...where.max_redemptions,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.coin_codes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'coin_codes',
                        'code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.coin_codes.findAll({
            attributes: [ 'id', 'code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.code,
        }));
    }

    
};

